# 2006.03.08 bug fix.

package sb::Plugin::RealTimeCalendar;

use sb::Plugin ();

sb::Plugin->register_plugin(
    'lang' => {
        'ja' => 'euc',
        'en' => 'ascii',
    },
    'text' => {
        'type'    => 'cms',
        'name'    => 'RealTimeCalendar',
        'text'    => 'script for Real Time Calendar',
        'author'  => 'yujiro',
        'detail'  => 'http://www.koikikukan.com/',
        'version' => '1.00',
    },
    'data' => 0,
    'file' => 'rtcalendar.txt',
);

sb::Plugin->register_content_module(
    'type'     => 'main',
    'callback' => \&sb::Content::RealTimeCalendar::_real_time_calendar,
    'field'    => 'rt_calendar',
);

package sb::Content::RealTimeCalendar;

sub _real_time_calendar {
    my $cms = shift;
    my %var = @_;
    my $data = <<EOF;
<script type="text/javascript">
<!--
function changeTodayClass(){
    var id = 'rt_calendar';
    var data = new Date();
    var year = data.getYear();
    year = (year < 2000) ? year + 1900 : year;
    var month = data.getMonth() + 1;
    if (month == '01') {
        month = '12';
        year--;
    } else {
        month--;
        if (month < 10) {
            month = '0' + month.toString();
        }
    }
    var text = year.toString() + month.toString();
    var date = data.getDate().toString();

    // check year and month
    var element = document.getElementById(id);
    var link;
    if(element.getElementsByTagName('br').length != 0){
        var elements = element.getElementsByTagName('a');
        for (i=0; i < elements.length; i++) {
            if(elements[i].innerHTML == '&lt;&lt;'){
                link = element.getElementsByTagName('a')[i].getAttribute('href');
                break;
            }
        }
    } else {
        // for calendar2
        if(element.innerHTML.indexOf('&lt;&lt;') != -1){
            elements = element.getElementsByTagName('a');
            for (i=0; i < elements.length; i++) {
                if(elements[i].innerHTML == '&lt;&lt;'){
                    link = element.getElementsByTagName('a')[i].getAttribute('href');
                    break;
                }
            }
        } else {
            link = element.getElementsByTagName('a')[0].getAttribute('href');
        }
    }
    if (link.indexOf(text) == -1) {
       return;
    }
    if (element.innerHTML.indexOf("--") != -1) {
        buf = element.innerHTML.split("--")[1];
    } else {
        buf = element.innerHTML;
    }

    // delete span
    buf = buf.replace(/<span class="today">(\\d+)<\\/span>/gi,"\$1");
    buf = buf.replace(/<span class=today>(\\d+)<\\/span>/gi,"\$1"); // for IE

    // add span
    buf = buf.replace('>'+date+'<','><span class="today">'+date+'</span><');
    buf = buf.replace(' '+date+' ',' <span class="today">'+date+'</span> ');   // for horizontal
    buf = buf.replace('\\n'+date+'<','\\n<span class="today">'+date+'</span><'); // for vertical
    if (element.innerHTML.indexOf("--") != -1) {
        element.innerHTML = element.innerHTML.split("--")[0] + '--' + buf + '--' +
                            element.innerHTML.split("--")[2] + '--' +
                            element.innerHTML.split("--")[3];
    } else {
        element.innerHTML = buf;
    }
}
changeTodayClass();
//-->
</script>
EOF
    $cms->tag('rt_calendar_script' => $data);
    return 1;
}

1;
__END__
